//+------------------------------------------------------------------+
//|                                                       ResSup.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Maroon
#property indicator_color2 Navy
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

extern int period=24;
extern int shift=10;
#define SIGNAL_BAR 1
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
  IndicatorShortName("ResSup"); 
  IndicatorBuffers(2);
  
  SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,0,Maroon);
  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexLabel(0,"Res");
  SetIndexShift(0,shift);
        
  SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,0,Navy);
  SetIndexBuffer(1,ExtMapBuffer2);
  SetIndexLabel(1,"Sup"); 
  SetIndexShift(1,shift); 
   
  ObjectCreate("Res",OBJ_HLINE,0,Time[0],NormalizeDouble(Close[iHighest(NULL,0,MODE_CLOSE,period,shift)],Digits));
  ObjectSet("Res", OBJPROP_COLOR, Maroon);                    
  ObjectCreate("Sup",OBJ_HLINE,0,Time[0],NormalizeDouble(Close[iLowest(NULL,0,MODE_CLOSE,period,shift)],Digits));
  ObjectSet("Sup", OBJPROP_COLOR, Navy);                                                        
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  ObjectDelete("Res");
  ObjectDelete("Sup");     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
 {
  int limit;
  int counted_bars = IndicatorCounted();
  if(counted_bars > 0) counted_bars--;
  limit = Bars - counted_bars;
 for (int i=0; i<limit; i++)
  {                                                                                     
  ExtMapBuffer1[i]=ObjectMove("Res",0,Time[0],NormalizeDouble(Close[iHighest(NULL,0,MODE_CLOSE,period,shift)],Digits));           
  ExtMapBuffer2[i]=ObjectMove("Sup",0,Time[0],NormalizeDouble(Close[iLowest(NULL,0,MODE_CLOSE,period,shift)],Digits));      
  double range=(NormalizeDouble(Close[iHighest(NULL,0,MODE_CLOSE,period,shift)],Digits))-
  NormalizeDouble(Close[iLowest(NULL,0,MODE_CLOSE,period,shift)],Digits);
  } 
//===================================================== ================================================================  
 static int PrevSignal = 0, PrevTime = 0;
 if(SIGNAL_BAR > 0 && Time[0] <= PrevTime) 
 return(0);
 PrevTime = Time[0];
 
if(PrevSignal <= 0)//----------------------------------------------------------------------------------------------------------------+
 {		    
 if(NormalizeDouble(Close [SIGNAL_BAR],Digits) - NormalizeDouble(ExtMapBuffer1[SIGNAL_BAR],Digits) > 0)   
  {			       
  PrevSignal = 1;	
  Alert("BUY");
  }
 }   
if(PrevSignal >= 0)//----------------------------------------------------------------------------------------------------------------+
 {
 if(NormalizeDouble(ExtMapBuffer1[SIGNAL_BAR],Digits) - NormalizeDouble(Close [SIGNAL_BAR],Digits) > 0) 
  {
  PrevSignal=-1;
  Alert("      "+DoubleToStr(range,Digits)+" .");
  }
 } 
if(PrevSignal <= 0)//----------------------------------------------------------------------------------------------------------------+
 {
 if(NormalizeDouble(ExtMapBuffer2[SIGNAL_BAR],Digits) - NormalizeDouble(Close [SIGNAL_BAR],Digits) > 0) 
  {
  PrevSignal = 1;
  Alert("SELL");			        			                  
  }
 }
if(PrevSignal >= 0)//----------------------------------------------------------------------------------------------------------------+
 {
 if(NormalizeDouble(Close [SIGNAL_BAR],Digits) - NormalizeDouble(ExtMapBuffer2[SIGNAL_BAR],Digits) > 0) 
  {
  PrevSignal = -1;
  Alert("     "+DoubleToStr(range,Digits)+" .");
  }
 }        
//====================================================================================================================================
  return(0);
 }























